#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <kernaux/multiboot2.h>

#include <assert.h>
#include <stdarg.h>
#include <stdio.h>

#include "multiboot2_info_example2.h"

static void my_printf(const char *format, ...)
{
    va_list va;
    va_start(va, format);
    vprintf(format, va);
    va_end(va);
}

int main()
{
    assert(KernAux_Multiboot2_Info_is_valid(
        &multiboot2_info_example2.multiboot2_info
    ));

    KernAux_Multiboot2_Info_print(
        &multiboot2_info_example2.multiboot2_info,
        my_printf
    );

    return 0;
}
